# SoRotateDiscDragger Class Reference
[Draggers]

`#include <Inventor/draggers/SoRotateDiscDragger.h>`

Inheritance diagram for SoRotateDiscDragger:

List of all members.

## Detailed Description

The SoRotateDiscDragger class is for rotating geometry around a single axis.

Here's how the dragger looks with it's default geometry in the inactive state:

Use an instance of this dragger class in your scenegraph to let the end-users of your application rotate geometry around a pre-defined axis vector in 3D.

The special feature of this dragger that sets it apart from the other draggers that provides rotation around an axis (like the SoRotateCylindricalDragger) is that it provides a convenient interface to rotate around an axis that is pointing in approximately the same direction as the camera. This is useful for interacting with for instance something like a "volume" knob.

For the dragger orientation and positioning itself, use some kind of transformation node in your scenegraph, as usual.

## Public Member Functions

| SoRotateDiscDragger (void)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFRotation | rotation

## Protected Member Functions

| ~SoRotateDiscDragger ()
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
void | dragStart (void)
void | drag (void)
void | dragFinish (void)

## Static Protected Member Functions

void | startCB (void *f, SoDragger *d)
void | motionCB (void *f, SoDragger *d)
void | doneCB (void *f, SoDragger *d)
void | fieldSensorCB (void *f, SoSensor *s)
void | valueChangedCB (void *f, SoDragger *d)

## Protected Attributes

SoFieldSensor * | fieldSensor
SbPlaneProjector * | planeProj

## Constructor & Destructor Documentation

SoRotateDiscDragger::SoRotateDiscDragger | ( | void |  | ) |

Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Node kit structure (new entries versus parent class marked with arrow prefix):

      CLASS SoRotateDiscDragger
      -->"this"
            "callbackList"
            "topSeparator"
               "motionMatrix"
               "geomSeparator"
      -->         "rotatorSwitch"
      -->            "rotator"
      -->            "rotatorActive"
      -->         "feedbackSwitch"
      -->            "feedback"
      -->            "feedbackActive"

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

      CLASS SoRotateDiscDragger
      PVT   "this",  SoRotateDiscDragger  ---
            "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
      PVT   "topSeparator",  SoSeparator  ---
      PVT   "motionMatrix",  SoMatrixTransform  ---
      PVT   "geomSeparator",  SoSeparator  ---
      PVT   "rotatorSwitch",  SoSwitch  ---
            "rotator",  SoSeparator  ---
            "rotatorActive",  SoSeparator  ---
      PVT   "feedbackSwitch",  SoSwitch  ---
            "feedback",  SoSeparator  ---
            "feedbackActive",  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

SoRotateDiscDragger::~SoRotateDiscDragger | ( |  | ) | `[protected]`

| Protected destructor. (Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

## Member Function Documentation

void SoRotateDiscDragger::initClass | ( | void |  | ) | `[static]`

| Initializes type system for this dragger class. Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init(). Reimplemented from SoDragger.

SbBool SoRotateDiscDragger::setUpConnections | ( | SbBool | onoff,
|  | SbBool | doitalways = FALSE
| ) | `[protected, virtual]`

| Sets up all internal connections for instances of this class. (This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.) Reimplemented from SoInteractionKit.

void SoRotateDiscDragger::startCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoRotateDiscDragger::motionCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoRotateDiscDragger::doneCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoRotateDiscDragger::fieldSensorCB | ( | void * | d,
|  | SoSensor * | s
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoInteractionKit.

void SoRotateDiscDragger::valueChangedCB | ( | void * | f,
|  | SoDragger * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoRotateDiscDragger::dragStart | ( | void |  | ) | `[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when dragger is selected (picked) by the user.

void SoRotateDiscDragger::drag | ( | void |  | ) | `[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when user drags the mouse after picking the dragger.

void SoRotateDiscDragger::dragFinish | ( | void |  | ) | `[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Called when mouse button is released after picking and interacting with the dragger.

## Member Data Documentation

SoSFRotation SoRotateDiscDragger::rotation

| This field is continuously updated to contain the rotation of the current direction vector of the dragger. The application programmer using this dragger in his scenegraph should connect the relevant node fields in the scene to this field to make them follow the dragger orientation.

SoFieldSensor * SoRotateDiscDragger::fieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoInteractionKit.

SbPlaneProjector * SoRotateDiscDragger::planeProj`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoRotateDiscDragger.h
- SoRotateDiscDragger.cpp